;   DS18b02
;      WDT
;   DS18b02     UART(HC-12)
;   . 12 (PB0)
; HC-12_peredatchik_2313_ds18b20.png

.device ATtiny2313
;4    (    UART)
;    11 (PD6)
.include "tn2313def.inc"

.equ	 pDQ	= 0 ;PB0, . 12

.def temp =r16 ; 
.def Razr0 = r17 ;r17-r18  
.def Razr1 = r18
.def data0 = r19
.def data1 = r20 ;data1:data0 -   
.def count = r21; 

;============  ============
rjmp RESET ;Reset Handle
.org WDTaddr
rjmp WDT_over ;External Interrupt Vector Address

;==========  ============

out_com:  ;   temp  . 
	sbis UCSRA,UDRE ;   
	rjmp out_com
	out	UDR,temp 
ret


; N   T ()  .  F () 
;N = TF/4; F= 4  
; T = 50 ms N= 50 000, $C3 50 = 195 80
; T = 500 mks N= 500, $01 F4 = 1 244
.macro Delay65 ;   65 
ldi Razr1,@0 ;  N
ldi Razr0,@1;  N
R_sub: 
 subi Razr0,1 
 sbci Razr1,0
brcc R_sub
.endm

; N   T (mks)  .  F () 
;N = TF/2; F= 4  ; N 2-254 = 1-127 mks
; T = 60 mks N= 120, $78 = 120
; T = 5 mks N= 10, $0A = 10
.macro Delay_mks ;   127 
ldi Razr0,@0 ; N
R_dec: 
 dec Razr0 
brne R_dec
.endm


; DS18b02 
ini_DS18b02:
	; DDRB,pDQ -   ,   R3 - . 1
	sbi DDRB,pDQ ;  
	;cbi PortB,pDQ ;- ,   , PortB     
	Delay65 1,244 ; 500 
	cbi DDRB,pDQ ;  ,   R3 - . 1
	Delay_mks 120 ; 60 
	sbic PinB,pDQ ; pDQ=0    
	rjmp err_1 ;  1
	Delay65 1,244 ; 500 
	sbis PinB,pDQ ; pDQ=1    
	rjmp err_2 ;  2
ret
err_1:
   ldi temp,$FC ; FC 
	rcall out_com ;  
   ldi temp,$FC ;  FC  - ,   
	rcall out_com ;
	set ; t (SREG)  - 
	ret
err_2:
   ldi temp,$FE ; FE 
	rcall out_com ;  
   ldi temp,$FE ;  FE  - ,   
	rcall out_com ;  
	set ; t (SREG)  - 
ret

;  = 0
Out_0:
	sbi DDRB,pDQ ;  
	;cbi PortB,pDQ ;- ,   , PortB     
	Delay_mks 120 ; 60 
	cbi DDRB,pDQ ;  ,   R3 - . 1
	Delay_mks 10 ; 10 
ret

;  = 1
Out_1:
	sbi DDRB,pDQ ;  
	;cbi PortB,pDQ ;- ,   , PortB     
	Delay_mks 10 ; 10 
	cbi DDRB,pDQ ;  ,   R3 - . 1
	Delay_mks 120 ; 60 
ret

; ,   temp 
Write_byte:
	ldi count,8 ;  8
write_loop:
		sbrc	temp, 0					; ,  .  = 0
		rcall	Out_1						;  "1" 
		sbrs	temp, 0					; ,  .  = "1"
		rcall	Out_0					;  "0" 
		lsr		temp						; 
	dec count
	brne write_loop ;  
ret

;   C
In_bit:
	clc 
	sbi DDRB,pDQ ;  
	;cbi PortB,pDQ ;- ,   , PortB     
	Delay_mks 12 ; 6 
	cbi DDRB,pDQ ;  ,   R3 - . 1
	Delay_mks 20 ; 10 
;    pDQ	 C
	sbic PinB,pDQ 
	sec
	Delay_mks 70 ; 35 
ret

; DS18b02 
conv_DS18b02:
	ldi temp,$CC ;   ROM
	rcall Write_byte
	ldi temp,$44 ;  
	rcall Write_byte
;	cbi DDRB,pDQ ;,   ,       Out
back_c:
	sbis PinB,pDQ ; pDQ=1   
	rjmp back_c
; 		
ret

;   temp
Read_byte:
	clr temp
	ldi count,8 
read_loop:	
	rcall In_bit
	ror temp ;  ->    temp
	dec count
	brne read_loop
ret

;    ,  ->  data1:data0
read_DS18b02:
	ldi temp,$CC ;   ROM
	rcall Write_byte
	ldi temp,$BE ;  
	rcall Write_byte
;
	rcall Read_byte ;.   temp
	mov data0, temp ;temp ->  data0
	rcall Read_byte ;.   temp
	mov data1, temp ;temp ->  data1
ret 

WDT_over: ;  Watchdog
 sbi PortD,6 ; 
 sbi PortD,5 ; 
 Delay65 195, 80 ; 50   4  

   rcall ini_DS18b02; 
   brts end_E ;  t = 1 ()    
   rcall conv_DS18b02;  
   rcall ini_DS18b02; 
   brts end_E ;  t = 1 ()    
	rcall read_DS18b02; 
	
;  data1:data0, 
	ldi temp,'D' ; D
	rcall out_com ;    
	ldi temp,'A' ; A
	rcall out_com ; 
	ldi temp,'T' ; T
	rcall out_com ; 
	mov temp,data0 ;  
	rcall out_com
	mov temp,data1 ; 
	rcall out_com
	ldi temp,';' ; ';',  
	rcall out_com ; 
 
end_E:
 Delay65 195, 80 ; 50   4  
	clt ;  t -  
 cbi PortD,6 ; 
 cbi PortD,5 ; 
reti ;  WDT


Reset:
	ldi		temp,low(RAMEND)   ;     	
	out	SPL,temp ; tiny2313  SPL

	ldi temp,1<<ACD	 
	out ACSR,temp ;. . 
	
ldi temp,0b01100000 ; D  PB5, PB6  
out DDRD,temp

;=== UART
	ldi temp,25 ;9600  4  + U2X
	out	UBRRL,temp ;. 
	ldi temp,(1<<RXEN|1<<TXEN)
	out	UCSRB,temp ;. / 8

;====  Watchdog,  !
 wdr ; WDT
 ldi temp,(1<<WDCE)|(1<<WDE) ;   +  
 out WDTCR,temp
 ldi temp, (1<<WDIE)|(1<< WDP3)|(1<< WDP0)  ;  +  (WDP3:0 = 1001 =8 )
 out WDTCR,temp
	
ldi temp,(1<< SM1)|(1<<SE) ; Sleep,  Power Down
out MCUCR,temp

sei ; 
	
Gcykle: ;  
	sleep ;  
 rjmp Gcykle 







