;       OLED/LCD- 16x2
;  162,  4 
;  ATmega8
;  4 

.equ E = 4 ;PD4 ( 6 )
.equ RS = 3 ;PD3 ( 5 )
/* DB4-DB7 PortC 0-3
PC0 (23) - DB4
PC1 (24) - DB5
PC2 (25) - DB6
PC3 (26) - DB7 
*/
;          
;      

.equ Addr = 7 ;7=1     RAM
.equ Str = 6 ;6=0 -  1, 6=1 -  2

.def temp	= r16 ;  
; r17- r19   ,     (. OLED16x02_clock.asm)
.def	Razr0 = r17 ; 
.def	Razr1= r18 ; 
.def	Razr2 = r19 ; 

LCD_ini: ;   LiqidCrystal
;ldi temp,0b00011000 ;PB3,PB4  
;out DDRD,temp
sbi  DDRD,E ; E (PB4)  RS (PB3)  
sbi  DDRD,RS
cbi PortD,E ;E=0
ldi temp,0b00001111 ;PC0-PC3  
out DDRC,temp
      
rcall Del_500ms ;  0,5  -  
ldi temp,0b00000011
rcall LCD_command	
rcall Del_5ms
ldi temp,0b00000011
rcall LCD_command	
rcall Del_5ms
ldi temp,0b00000011
rcall LCD_command	
rcall Del_5ms
ldi temp,0b00000010
rcall LCD_command	
rcall Del_5ms
#ifdef Rus_table 
; Wistar OLED
ldi temp,0b00101010 ;DL=1 - 4 bit  N=1 - 2, FT=10 - / 
#else
;  / 
ldi temp,0b00101000 ;DL=1 - 4 bit  N=1 - 2, 
#endif
rcall LCD_command_4bit	
rcall Del_5ms
ldi temp,0b00001000 
rcall LCD_command_4bit ; Off	
rcall Del_5ms
ldi temp,0b00000001 
rcall LCD_command_4bit ; clear 
rcall Del_5ms
ldi temp,0b00000110 
rcall LCD_command_4bit ;I/D=1 -  S=0 -  
rcall Del_5ms
#ifdef Blink
;  
ldi temp,0b00001101 ;D=1-  On B=1 -     
#else
; 
ldi temp,0b00001100 ;D=1-  On
#endif
rcall LCD_command_4bit 
rcall Del_5ms
ldi temp,0b10000000 ;   0,0
rcall LCD_command_4bit ;
rcall Del_5ms
ret

.macro Set_cursor
push temp ;     temp
ldi temp,(1<<Addr)|(@0<<Str)+@1 ;  @0 (0-1)  @1 (0-15)
rcall LCD_command_4bit ;
rcall Del_5ms
pop temp
.endm

Symbol_degree: ;  
ldi temp,0b01001000 ;CGRAM  001
rcall LCD_command_4bit ;
rcall Del_5ms
ldi temp,0b00001100 
rcall LCD_data
ldi temp,0b00010010 
rcall LCD_data
ldi temp,0b00010010 
rcall LCD_data
ldi temp,0b00001100 
rcall LCD_data
ldi temp,0b00000000 
rcall LCD_data
ldi temp,0b00000000 
rcall LCD_data
ldi temp,0b00000000 
rcall LCD_data
ldi temp,0b00000000 
rcall LCD_data
ldi temp,0b10000000 ;   0,0
rcall LCD_command_4bit ;
rcall Del_5ms
ret

LCD_data:  ;    temp  2 
#ifdef Zerosymb
cpi temp,$30 ;  
brne Z_ok
ldi temp,'O' ;    
Z_ok:
#endif
sbi PortD,RS ;RS=1
swap temp ;
out PortC,temp ;  PC0..3
sbi PortD,E ;E=1 -  1 mks
nop ;1 mks
nop
nop
nop
cbi PortD,E ;E=0
nop ;1 mks
nop
nop
nop
swap temp ;
out PortC,temp ;  PC0..3
sbi PortD,E ;E=1 -  1 mks
nop ;1 mks
nop
nop
nop
cbi PortD,E ;E=0
rcall Del_150mks
ret

LCD_command: ;       temp 
cbi PortD,RS ;RS=0
out PortC,temp ;  PC3..0
sbi PortD,E ;E=1 -  1 mks
nop ;1 mks
nop
nop
nop
cbi PortD,E ;E=0
ret

LCD_command_4bit: ;    temp   
cbi PortD,RS ;RS=0
swap temp ;
out PortC,temp ;  PC0..3
sbi PortD,E ;E=1 -  1 mks
nop ;1 mks
nop
nop
nop
cbi PortD,E ;E=0
nop ;1 mks
nop
nop
nop
swap temp ;
out PortC,temp ;  PC0..3
sbi PortD,E ;E=1 -  1 mks
nop ;1 mks
nop
nop
nop
cbi PortD,E ;E=0
ret

; N   T ()  .  F () 
;N = TF/3    150 mks = 200  4 
Del_150mks: ;   150 
cli ; 
	push	Razr0
	ldi	Razr0,200 ;
Del_50: 	dec Razr0
	brne	Del_50
	pop	Razr0
sei ; 	
ret

;N = TF/4     5 ms = 5000  4 
Del_5ms: 
cli ; 
	push	Razr0
	push	Razr1
ldi Razr1,high(5000) ;  N
ldi Razr0,low(5000) ;  N
R5_sub: 
 subi Razr0,1 
 sbci Razr1,0
brcc R5_sub
	pop	Razr1
	pop	Razr0
sei ; 	
ret

;N = TF/5     500 ms = 400000  4 
Del_500ms: 
cli ; 
	push	Razr0
	push	Razr1
	push	Razr2
ldi Razr2,byte3(400000) ;  N
ldi Razr1,high(400000) ;  N
ldi Razr0,low(400000) ;  N
R200_sub: 
 subi Razr0,1 
 sbci Razr1,0
 sbci Razr2,0
brcc R200_sub
	pop	Razr2
	pop	Razr1
	pop	Razr0
sei ; 	
ret
